version: "3.9"
services:
  loki:
    user: "$UID:$GID"
    image: grafana/loki:{{ cloudstack.plugins.loki.version }}
    container_name: loki
    restart: unless-stopped
    ports:
      - "127.0.0.1:3100:3100"
    command: -config.file=/etc/loki/local-config.yaml
    volumes:
      - /opt/cloudstack/loki/data:/tmp/loki
      - /opt/cloudstack/loki/loki-local-config.yaml:/etc/loki/local-config.yaml
    networks:
      - loki
      - s3
      - traefik
    labels:
      - 'traefik.enable=true'
      - 'traefik.docker.network=traefik'
      - 'traefik.http.routers.loki.rule=Host(`{{ cloudstack.plugins.loki.config.sitename }}`)'
      - 'traefik.http.routers.loki.entrypoints=websecure'
      - 'traefik.http.routers.loki.service=loki'
      - 'traefik.http.services.loki.loadbalancer.server.port=3100'
      - 'traefik.http.services.loki.loadbalancer.passhostheader=true'
      - 'traefik.http.routers.loki.middlewares=redirect-to-https@docker,loki-auth@docker'
      - 'traefik.http.middlewares.loki-auth.basicauth.users={{ cloudstack.plugins.loki.config.auth.user }}:{{ cloudstack.plugins.loki.config.auth.password_hash }}'

  promtail:
    image: grafana/promtail:{{ cloudstack.plugins.loki.version }}
    restart: always
    volumes:
      - /var/log:/var/log
      - /var/lib/docker/containers:/var/lib/docker/containers
      - /opt/cloudstack/loki/promtail-docker-config.yaml:/etc/promtail/config.yaml
    command: -config.file=/etc/promtail/config.yaml
    networks:
      - loki

networks:
  traefik:
    external: true
  loki:
    name: loki
  s3:
    external: true
